var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import Fetch from './Fetch';
var mapList = function mapList(props) {
  return function (data, reload) {
    return React.createElement(
      'div',
      null,
      React.createElement(
        'ul',
        null,
        data.map(function (post, index) {
          return Array.isArray(post) ? React.createElement(
            'li',
            { key: index },
            index,
            mapList(props)(post)
          ) : React.createElement(
            'li',
            { key: post.id },
            post.title
          );
        })
      ),
      React.createElement(
        'button',
        { onClick: function onClick(e) {
            return reload(props);
          } },
        'Reload'
      )
    );
  };
};

var AsyncList = function AsyncList(props) {
  return React.createElement(Fetch, _extends({
    onLoading: function onLoading(props, cancel) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          'p',
          null,
          'Loading ',
          props.url,
          '...'
        ),
        React.createElement(
          'button',
          { onClick: function onClick(e) {
              return cancel();
            } },
          'Cancel?'
        )
      );
    },
    onSuccess: mapList(props),
    onCancel: function onCancel(props, reload) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          'p',
          null,
          'Canceled'
        ),
        React.createElement(
          'button',
          { onClick: function onClick(e) {
              return reload(props);
            } },
          'Reload?'
        )
      );
    },
    onError: function onError(error, reload) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          'p',
          null,
          'Error!'
        ),
        React.createElement(
          'pre',
          null,
          error.message
        ),
        React.createElement(
          'button',
          { onClick: function onClick(e) {
              return reload(props);
            } },
          'Reload?'
        )
      );
    }
  }, props));
};

export default AsyncList;