var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import isFunction from 'lodash/isFunction';
import Promised from './Promised';

var createFetch = function createFetch(config) {
  return function (url) {
    return global.fetch(url, config).then(function (res) {
      return res.json();
    });
  };
};

var Fetch = function Fetch(props) {
  return React.createElement(
    Promised,
    _extends({
      getPromise: function getPromise(props) {
        if (isFunction(props.handleLoading)) {
          props.handleLoading(props);
        }
        return (props.url ? Array.isArray(props.url) ? Promise.all(props.url.map(createFetch(props.config))) : createFetch(props.config)(props.url) : Promise.resolve()).then(function (res) {
          if (isFunction(props.handleSuccess)) {
            props.handleSuccess(res);
          }
          return res;
        }, function (err) {
          if (isFunction(props.handleError)) {
            props.handleError(err);
            return err;
          }
          throw err;
        });
      }
    }, props),
    props.children
  );
};

export default Fetch;