import _regeneratorRuntime from 'babel-runtime/regenerator';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2, _initialiseProps;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import set from 'lodash/fp/set';
import get from 'lodash/get';
import isFunction from 'lodash/isFunction';
import isArray from 'lodash/isArray';

var getValue = function getValue(e) {
	var value = get(e, 'target.files[0]', get(e, 'currentTarget.files[0]', get(e, 'target.value', get(e, 'currentTarget.value'))));
	if (value instanceof File) {
		return value;
	}
	try {
		return JSON.parse(value);
	} catch (e) {
		return value;
	}
};

var getName = function getName(path) {
	return isArray(path) ? path.map(function (e, i) {
		return i ? '[' + e + ']' : e;
	}).join('') : path;
};

var Form = (_temp2 = _class = function (_React$Component) {
	_inherits(Form, _React$Component);

	function Form() {
		var _temp, _this, _ret;

		_classCallCheck(this, Form);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
	}

	Form.prototype.componentDidMount = function componentDidMount() {
		this.mounted = true;
	};

	Form.prototype.componentWillUnmount = function componentWillUnmount() {
		this.mounted = false;
	};

	Form.prototype.render = function render() {
		var handleSubmit = this.handleSubmit,
		    state = this.state,
		    bindFormData = this.bindFormData,
		    props = this.props;
		var fields = props.fields,
		    children = props.children,
		    renderFields = props.renderFields;

		return React.createElement(
			'form',
			{ onSubmit: handleSubmit },
			isArray(fields) ? fields.map(renderFields || children) : null,
			isFunction(children) ? children(state, bindFormData) : children
		);
	};

	return Form;
}(React.Component), _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.mounted = false;
	this.state = {
		loading: false,
		formData: _extends({}, this.props.initialFormData),
		response: false
	};

	this.update = function () {
		var mounted = _this2.mounted;

		if (mounted) {
			_this2.setState.apply(_this2, arguments);
		}
	};

	this.bindFormData = function (path) {
		var update = _this2.update,
		    state = _this2.state;

		var value = get(state.formData, path, '');
		return {
			value: value instanceof File ? undefined : value,
			name: getName(path),
			onChange: function onChange(e) {
				if (e && e.persist) {
					e.persist();
				}
				update(function (state) {
					return {
						response: false,
						formData: set(path, getValue(e), state.formData)
					};
				});
			}
		};
	};

	this.handleSubmit = function () {
		var _ref = _asyncToGenerator(_regeneratorRuntime.mark(function _callee(e) {
			var update, props, state, onSubmit, response;
			return _regeneratorRuntime.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							update = _this2.update, props = _this2.props, state = _this2.state;
							onSubmit = props.onSubmit;

							e.preventDefault();
							e.stopPropagation();
							update({ loading: true });
							response = null;
							_context.prev = 6;
							_context.next = 9;
							return onSubmit(state.formData);

						case 9:
							response = _context.sent;
							_context.next = 15;
							break;

						case 12:
							_context.prev = 12;
							_context.t0 = _context['catch'](6);

							response = _context.t0;

						case 15:
							update({ response: response, loading: false });

						case 16:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, _this2, [[6, 12]]);
		}));

		return function (_x) {
			return _ref.apply(this, arguments);
		};
	}();
}, _temp2);
export { Form as default };