'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Fetch = require('./Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapList = function mapList(props) {
  return function (data, reload) {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'ul',
        null,
        data.map(function (post, index) {
          return Array.isArray(post) ? _react2.default.createElement(
            'li',
            { key: index },
            index,
            mapList(props)(post)
          ) : _react2.default.createElement(
            'li',
            { key: post.id },
            post.title
          );
        })
      ),
      _react2.default.createElement(
        'button',
        { onClick: function onClick(e) {
            return reload(props);
          } },
        'Reload'
      )
    );
  };
};

var AsyncList = function AsyncList(props) {
  return _react2.default.createElement(_Fetch2.default, _extends({
    onLoading: function onLoading(props, cancel) {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'p',
          null,
          'Loading ',
          props.url,
          '...'
        ),
        _react2.default.createElement(
          'button',
          { onClick: function onClick(e) {
              return cancel();
            } },
          'Cancel?'
        )
      );
    },
    onSuccess: mapList(props),
    onCancel: function onCancel(props, reload) {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'p',
          null,
          'Canceled'
        ),
        _react2.default.createElement(
          'button',
          { onClick: function onClick(e) {
              return reload(props);
            } },
          'Reload?'
        )
      );
    },
    onError: function onError(error, reload) {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'p',
          null,
          'Error!'
        ),
        _react2.default.createElement(
          'pre',
          null,
          error.message
        ),
        _react2.default.createElement(
          'button',
          { onClick: function onClick(e) {
              return reload(props);
            } },
          'Reload?'
        )
      );
    }
  }, props));
};

exports.default = AsyncList;
module.exports = exports['default'];