'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _Promised = require('./Promised');

var _Promised2 = _interopRequireDefault(_Promised);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createFetch = function createFetch(config) {
  return function (url) {
    return global.fetch(url, config).then(function (res) {
      return res.json();
    });
  };
};

var Fetch = function Fetch(props) {
  return _react2.default.createElement(
    _Promised2.default,
    _extends({
      getPromise: function getPromise(props) {
        if ((0, _isFunction2.default)(props.handleLoading)) {
          props.handleLoading(props);
        }
        return (props.url ? Array.isArray(props.url) ? Promise.all(props.url.map(createFetch(props.config))) : createFetch(props.config)(props.url) : Promise.resolve()).then(function (res) {
          if ((0, _isFunction2.default)(props.handleSuccess)) {
            props.handleSuccess(res);
          }
          return res;
        }, function (err) {
          if ((0, _isFunction2.default)(props.handleError)) {
            props.handleError(err);
            return err;
          }
          throw err;
        });
      }
    }, props),
    props.children
  );
};

exports.default = Fetch;
module.exports = exports['default'];