'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cache = {};

var PromiseComponent = function (_React$Component) {
	_inherits(PromiseComponent, _React$Component);

	function PromiseComponent() {
		var _temp, _this, _ret;

		_classCallCheck(this, PromiseComponent);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
			data: false,
			canceled: false,
			loading: true
		}, _this.getPromise = function (props) {
			var hash = void 0;
			if (props.cache) {
				try {
					hash = btoa(JSON.stringify(props));
				} catch (e) {
					console.error('Please use a seriazable props when you enable cache', props, e);
				}
			}
			_this.update({
				canceled: false,
				data: props.cache ? cache[hash] : false,
				loading: true,
				error: false
			});
			return props.getPromise(props).then(function (data) {
				cache[hash] = data;
				_this.update({ data: data, error: false, loading: false });
			}, function (error) {
				_this.update({ error: error, data: false, loading: false });
			});
		}, _this.reload = function (newProps) {
			return _this.getPromise(_extends({}, _this.props, newProps));
		}, _this.handleCancel = function () {
			return _this.update({ canceled: true });
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	PromiseComponent.prototype.componentDidMount = function componentDidMount() {
		this.mounted = true;
		this.getPromise(this.props);
	};

	PromiseComponent.prototype.componentWillUnmount = function componentWillUnmount() {
		this.mounted = false;
	};

	PromiseComponent.prototype.update = function update() {
		if (this.mounted) {
			this.setState.apply(this, arguments);
		}
	};

	PromiseComponent.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
		if (!(0, _isEqual2.default)(nextProps, this.props)) {
			this.getPromise(nextProps);
		}
	};

	PromiseComponent.prototype.render = function render() {
		try {
			if (this.state.canceled && this.props.onCancel) {
				return this.props.onCancel(this.props, this.reload);
			}

			if (this.props.children) {
				return this.props.children(this.state.data, this.state, this.props);
			}

			if (!this.state.data && this.state.loading && this.props.onLoading) {
				return this.props.onLoading(this.props, this.handleCancel);
			}

			if (this.state.error && this.props.onError) {
				return this.props.onError(this.state.error, this.reload);
			}

			if (this.state.data && this.props.onSuccess) {
				return this.props.onSuccess(this.state.data, this.reload);
			}
		} catch (e) {
			return this.props.onError(e, this.reload);
		}

		return null;
	};

	return PromiseComponent;
}(_react2.default.Component);

exports.default = PromiseComponent;
module.exports = exports['default'];