'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var merge = Object.assign;

exports.default = function (state, handleUpdate) {
  var subscribers = [];
  var currentState = merge(state, {
    set: function set() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      subscribers.forEach(function (subscriber) {
        return subscriber.setState.apply(subscriber, args);
      });
      return state;
    }
  });

  return function connect(Component) {
    var _class, _temp2;

    return _temp2 = _class = function (_React$PureComponent) {
      _inherits(_class, _React$PureComponent);

      function _class() {
        var _temp, _this, _ret;

        _classCallCheck(this, _class);

        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args))), _this), _this.state = currentState, _this.handleUpdate = function (oldState) {
          if (typeof handleUpdate === 'function') {
            handleUpdate(_this.state, oldState);
          }
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _class.prototype.componentWillMount = function componentWillMount() {
        if (subscribers.indexOf(this) === -1) {
          subscribers.push(this);
          this.handleUpdate(this.props);
        }
      };

      _class.prototype.componentWillUnmount = function componentWillUnmount() {
        subscribers.splice(subscribers.indexOf(this), 1);
      };

      _class.prototype.componentDidUpdate = function componentDidUpdate(_, oldState) {
        if (subscribers.indexOf(this) === 0) {
          merge(currentState, this.state);
          this.handleUpdate(oldState);
        }
      };

      _class.prototype.render = function render() {
        return _react2.default.createElement(Component, _extends({}, this.props, this.state));
      };

      return _class;
    }(_react2.default.PureComponent), _class.displayName = 'connected(' + (Component.name || Component.displayName) + ')', _temp2;
  };
};

module.exports = exports['default'];